<template>
  <div class="d-flex flex-column">
    <Navbar :isAuthenticated="userStore.isAuthenticated" @logout="logout()" />
    <RouterView />
  </div>
</template>

<script setup lang="ts">
import Navbar from "@/components/Navbar/Navbar.vue";
import { onMounted } from "vue";
import { RouterView, useRouter } from "vue-router";
import { useUser } from "./shared/stores";
import jwt_decode from "jwt-decode";

const userStore = useUser();
const router = useRouter();

async function logout() {
  await userStore.logout();
  router.push("/login");
}

interface TokenPayload{
  exp: number
}

function checkexpire(){
  if (userStore.token) {
    let decoded = jwt_decode(userStore.token) as TokenPayload;
    if(decoded.exp*1000 < Date.now()){
      userStore.logout()
      location.reload()
    }
  }
}

onMounted(() => {
  checkexpire()
  if(userStore.token){
    userStore.fetchCurrentUser()
  }
  setInterval(checkexpire, 5*60*1000)
});
</script>

<style scoped lang="scss"></style>
